// ----------------------------------------------------------------------------
// CGPUmesh_primitives.h
//

//
//                                                    (c) Sylvain Lefebvre 2003
// ----------------------------------------------------------------------------

#ifndef __GPUMESH_PRIMITIVES__
#define __GPUMESH_PRIMITIVES__

namespace GPUmesh {

class PrimitiveNfo
{
private:
  int  m_iNbPrim;
  bool m_bValid;
public:
  PrimitiveNfo(int primtype,int nbidx)
  {
    switch (primtype)
    {
    case GPUMESH_TRIANGLELIST:
      m_iNbPrim = nbidx/3;
      m_bValid  = (nbidx % 3 == 0);
      break;
    case GPUMESH_TRIANGLEFAN:
    case GPUMESH_TRIANGLESTRIP:
      m_iNbPrim = nbidx-2;
      m_bValid  = (nbidx > 2);
      break;
    case GPUMESH_QUADS:
      m_iNbPrim = nbidx/4;
      m_bValid  = (nbidx % 4 == 0);
      break;
    default:
      m_iNbPrim=0;
      m_bValid=false;
      break;
    }
    if (primtype < 0)
    {
      m_iNbPrim=0;
      m_bValid=false;
    }
  }

  const int&  nbPrim() const {return (m_iNbPrim);}
  const bool& valid() const {return (m_bValid);}
};

} // namespace GPUmesh

#endif
